#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define HEXA_STRING "0123456789abcdef"

#ifdef WIN32
#define MKSTEMP mktemp
#else
#define MKSTEMP mkstemp
#endif

char idx[1024], ind[1024];
int cho=-1, style_used=0;
int to_8bit(void);
int hangul_head(void);

main(int argc, char *argv[])
{
  int i, outfile_used=0;
  char prog[1024], args[1024], cmd[128], idx0[1024];
  char *t, *l;

  strcpy(prog, argv[0]);
#ifdef WIN32
  strcpy(args, "");
  strcpy(ind, "");
#else
  bzero(args, 1024);
  bzero(ind, 1024);
#endif

  for(i=1; i<argc; i++) {
    strcat(args, " ");
    t=argv[i];
    strcat(args, t);
    switch(*t) {
    case '-':
      t++;
      switch(*t) {
      case 'o':
	outfile_used=1;
	strcat(args, " ");
	strcat(args, argv[++i]);
	strcpy(ind, argv[i]);
	if((l=strrchr(ind, '.'))&&*(l+1)=='i'&&*(l+2)=='n'&&*(l+3)=='d')
	  *l=0;
	break;
      case 'p':
	strcat(args, " ");
	strcat(args, argv[++i]);
	break;
      case 's':
	strcat(args, " ");
	strcat(args, argv[++i]);
	style_used=1;
	break;
      case 't':
	strcat(args, " ");
	strcat(args, argv[++i]);
	break;
      default:
	break;
      }
      break;
    default:
      if((l=strrchr(argv[i], '.'))&&*(l+1)=='i'&&*(l+2)=='d'&&*(l+3)=='x')
	*l=0;
      strcpy(idx, argv[i]);
      strcpy(idx0, argv[i]);
      strcat(idx, ".idx");
      to_8bit();
      break;
    }
  }

  sprintf(cmd, "makeindex %s", args);
  system(cmd);

  if(outfile_used==0) {
    strcpy(ind, idx0);
    strcat(ind, ".ind");
  }
  hangul_head();

  exit(0);
}

int to_8bit() {
  FILE *in, *out;
  char line[1024], *l, *h1, *h2, tempfile[10];

  strcpy(tempfile, "IDXXXXXXX");
  MKSTEMP(tempfile);

  in = fopen(idx, "r");
  out = fopen(tempfile, "w");

  while(fgets(line, 1024, in)) {
    l=line;
    while(*l) {
      if(*l=='^'&&*(l+1)=='^'
	 &&(h1=strchr(HEXA_STRING, *(l+2)))
	 &&(h2=strchr(HEXA_STRING, *(l+3)))) {
	int x;
	if(*h1>'9') x=*h1-87;
	else x=*h1-48;
	x*=16;
	if(*h2>'9') x+=*h2-87;
	else x+=*h2-48;
	fputc(x, out);
	l+=4;
      }
      else {
	fputc(*l++, out);
      }
    }
  }
  fflush(NULL);
  fclose(in);
  fclose(out);

  in=fopen(tempfile, "r");
  out=fopen(idx, "w");
  while(fgets(line, 1024, in)) fputs(line, out);
  fflush(NULL);
  fclose(in);
  fclose(out);

  (void)unlink(tempfile);
  return(1);
}

int hangul_head() {
  FILE *in, *out;
  char tempfile[10];
  unsigned char line[1024], *l;

  strcpy(tempfile, "INDXXXXXX");
  MKSTEMP(tempfile);
  in=fopen(ind, "r");
  out=fopen(tempfile, "w");

  if(style_used==0)
    fputs("\\def\\hindexhead#1{\\indexspace}\n", out);

  while(fgets(line, 1024, in)) {
    l=line;
    while(isspace(*l)) l++;
    if(strncmp(l, "\\item", 5)==0 && cho!=100) {
      l+=5;
      while(isspace(*l)) l++;
      if(234 <= *l && *l <= 237 &&
	 128 <= *(l+1) && *(l+1) <= 191 &&
	 128 <= *(l+2) && *(l+2) <= 191) {
	int x;
	x=(*l-224)<<12;
	x+=(*(l+1)-128)<<6;
	x+=*(l+2)-128;
	x-=44032;
	x/=21*28;
	if(x!=cho) {
	  cho=x;
	  fprintf(out, "\n  \\hindexhead{%d}\n", cho);
	}
      }
      else if(cho!=-1) cho=100;
    }
    if(strncmp(l, "\\indexspace", 11)==0) {
      if(cho==-1 || cho==100) fputs(line, out);
    }
    else if(!(strncmp(l, "\\indexhead{", 11)==0&&*(l+11)>128)) {
      fputs(line, out);
    }
  }

  fflush(NULL);
  fclose(in);
  fclose(out);

  in=fopen(tempfile, "r");
  out=fopen(ind, "w");
  while(fgets(line, 1024, in)) fputs(line, out);
  fflush(NULL);
  fclose(in);
  fclose(out);

  (void)unlink(tempfile);

  return(1);
}
