" Maintainer:   Jungshik Shin <jshin@mailaps.org>
" Last Changed: 2002-05-08
"
" Keymap file for Korean Input. 
" 
" leading consonants are typed in with lower case letters.
" trailing consonants are typed in with upper case letters.

" r, R : leading ㄹ(Rieul),  final ㄹ (Rieul)
" l,L  : denotes lighter consonants of preceding 
"        labial consonants represented by   m/M, b/B, bb/BB.
"    e.g.  ㅸ (labial light) => bl/BL, ㅱ => ml/ML
" f    : Yeorin Hieuh (arbitrary)  : ㆆ
" q    : leading YetIeung  ㆁ
" z    : PanSios ㅿ
" ng   : map to either trailing Ieung or trailing YetIeung.
"        For 15th century text, the latter is a better choice
"        because it was used to denote [ng] at the syllable coda position.
"        In that case, X should be used for trailing IEung.
"        If 'ng' is mapped to trailing IEung, 'Q' can be used
"        for trailing YetIEung.
"        Sometime during the 16th century, it got obsolete and
"        its place was taken over by Ieung. 
" x,0,O : leading Ieung (a place holder for a syllable beg. with a vowel) 
" X     : trailing Ieung. In 15th century orthography, it has no phonetic 
"         value but just used as a place holder when transcribing 
"         pronunciation of Chinese. 
"  )   : Leading consonant filler (shift-0)
"  (   : Medial vowel filler

"  A   : Arae Ah (ㆍ)

let b:keymap_name = "midkor"
loadkeymap

d     <char-0x110b>
g     <char-0x1100>
gg    <char-0x1101>
n     <char-0x1102>
d     <char-0x1103>
dd    <char-0x1104>
r     <char-0x1105>
m     <char-0x1106>
b     <char-0x1107>
bb    <char-0x1108>
s	<char-0x1109>
ss	<char-0x110a>
" We need to type intial Ieung too often, but 
" I'm not sure which one is the best, 0, x, or O. 
0	<char-0x110B> : we need to type intial Ieung too often and
x	<char-0x110B>   
O	<char-0x110B>  
j	<char-0x110c>
jj	<char-0x110d>
c	<char-0x110e>
k	<char-0x110f>
t	<char-0x1110>
p	<char-0x1111>
h	<char-0x1112>
lg	<char-0x1113> " Nieun-Giyeog: special case
nn    <char-0x<char-0x1114>>
nd	<char-0x1115>
nb	<char-0x1116>
dg	<char-0x1117>
rn	<char-0x1118>
rr	<char-0x1119>
rh	<char-0x111a>
rl	<char-0x111b>  " l denotes 'light'
mb	<char-0x111c>
ml	<char-0x111d>
bg	<char-0x111e>
bn	<char-0x111f>
bd	<char-0x1120>
bs	<char-0x1121>
"  omit clusters of three for the moment
bj	<char-0x1127>
bc	<char-0x1128>
bt	<char-0x1129>
bp	<char-0x112a>
bl	<char-0x112b>
"bbl	<char-0x112c>
sg	<char-0x112d>
sn	<char-0x112e>
sd	<char-0x112f>
sr	<char-0x1130>
sm	<char-0x1131>
sb	<char-0x1132>
" omit clusters of three
s0	<char-0x1135>
sj	<char-0x1136>
sc	<char-0x1137>
sk	<char-0x1138>
st	<char-0x1139>
sp	<char-0x113a>
sh	<char-0x113b>
z	<char-0x1140>
0g	<char-0x1141>
00      <char-0x1147>
q   <char-0x114c>   " leading consonant YetIeung
hh	<char-0x1158>
f	<char-0x1159>     " YeoRinHieuh
" omit cluster of Ieung + another consonant

)  <char-0x115f>  Leading consonant filler

" Medial vowels
( <char-0x1160>
a	<char-0x1161>
ae	<char-0x1162>
ya	<char-0x1163>
yae	<char-0x1164>
eo	<char-0x1165>
e	<char-0x1166>
yeo	<char-0x1167>
ye	<char-0x1168>
o	<char-0x1169>
wa	<char-0x116a>
wae	<char-0x116b>
oe	<char-0x116c>
yo	<char-0x116d>
u	<char-0x116e>
weo	<char-0x116f>
we	<char-0x1170>
wi	<char-0x1171>
ui	<char-0x1171>
yu	<char-0x1172>
eu	<char-0x1173>
Eu	<char-0x1174>
eui	<char-0x1174>
i	<char-0x1175>
A	<char-0x119e>
Ai <char-0x11a1>


" trailing consonants (all caps)
G	<char-0x11A8>
GG	<char-0x11a9>
GS	<char-0x11aa>
N	<char-0x11ab>
NJ	<char-0x11ac>
NH	<char-0x11ad>
D	<char-0x11AE>
R	<char-0x11AF>
RG	<char-0x11B0>
RM	<char-0x11b1>
RB	<char-0x11b2>
RS	<char-0x11b3>
RT	<char-0x11b4>
RP	<char-0x11b5>
RH	<char-0x11b6>
M	<char-0x11b7>
B	<char-0x11b8>
BS	<char-0x11b9>
S	<char-0x11ba>
SS	<char-0x11bb>
"  see below.
J	<char-0x11bd>
C	<char-0x11be>
K	<char-0x11bf>
T	<char-0x11c0>
P	<char-0x11c1>
H	<char-0x11c2>
GR	<char-0x11c3>
NG	<char-0x11c5>
ND	<char-0x11c6>
NS	<char-0x11c7>
NZ	<char-0x11c8>
NT	<char-0x11c9>
DG	<char-0x11ca>
DR	<char-0x11cb>
RN	<char-0x11cd>
RD	<char-0x11ce>
RR	<char-0x11d0>
RZ	<char-0x11d7>
RK	<char-0x11d8>
RF	<char-0x11d9>
MG	<char-0x11da>
MR	<char-0x11db>
MB	<char-0x11dc>
MS	<char-0x11dd>
MZ	<char-0x11df>
MC	<char-0x11e0>
MH	<char-0x11e1>
ML	<char-0x11e2>
BR	<char-0x11e3>
BP	<char-0x11e4>
Bh	<char-0x11e5>
BL	<char-0x11e6>
Bl	<char-0x11e6>
SG	<char-0x11e7>
SD	<char-0x11e8>
SR	<char-0x11e9>
SB	<char-0x11ea> 
Z	<char-0x11eb>  " BanSiOs

F	<char-0x11f9>    "YeoRin Hieuh

" Sometime during 16th century, YetIeung was replaced by Ieung 
" for  [ng].  
"ng	<char-0x11bc>  "trailing Ieung

" Use the following for 15th century text in which Yet Ieung is used
" for  [ng] 
ng	<char-0x11f0>  "Yet Ieung

" In either case, trailing Ieung and trailing YetIeung are mapped
" to X and Q, respectively.
X	<char-0x11bc>  "trailing Ieung
Q	<char-0x11f0>  "trailing Yet Ieung
